Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class BinaryExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.BinaryExpression

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, Locator

Direct Known Subclasses:
  ArithmeticExpression, ArithmeticExpression10, BooleanExpression, EquivalenceComparison, GeneralComparison, GeneralComparison10, IdentityComparison, RangeExpression, SingletonComparison, ValueComparison, VennExpression

    public abstract class BinaryExpression

extends Expression

Binary Expression: a numeric or boolean expression consisting of the two operands and an operator

See Also:
  Serialized Form

Field Summary
`protected Expression` | `operand0`
`protected Expression` | `operand1`
`protected int` | `operator`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`BinaryExpression(Expression p0, int op, Expression p1)` Create a binary expression identifying the two operands and the operator

Method Summary
`int` | `computeCardinality()` Determine the static cardinality.
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`protected String` | `displayOperator()` Display the operator used by this binary expression
`boolean` | `equals(Object other)` Is this expression the same as another expression?
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`protected void` | `explainExtraAttributes(ExpressionPresenter out)` Add subclass-specific attributes to the expression tree explanation.
`Expression[]` | `getOperands()` Get the operands
`int` | `getOperator()` Get the operator
`int` | `hashCode()` Get a hashCode for comparing two expressions.
`protected static boolean` | `isAssociative(int operator)` Determine whether an operator is associative, that is, ((a^b)^c) = (a^(b^c))
`protected static boolean` | `isCommutative(int operator)` Determine whether a binary operator is commutative, that is, A op B = B op A.
`protected static boolean` | `isInverse(int op1, int op2)` Test if one operator is the inverse of another, so that (A op1 B) is equivalent to (B op2 A).
`Iterator<Expression>` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
`Expression` | `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `promote(PromotionOffer offer, Expression parent)` Promote this expression if possible
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` | `setFlattened(boolean flattened)` Mark an expression as being "flattened".
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression
`String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
`Expression` | `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression.

Methods inherited from class net.sf.saxon.expr.Expression
`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, copy, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionName, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getItemType, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### operand0

    protected Expression operand0

### operand1

    protected Expression operand1

### operator

    protected int operator

Constructor Detail

### BinaryExpression

    public BinaryExpression(Expression p0,
                            int op,
                            Expression p1)

  Create a binary expression identifying the two operands and the operator

  Parameters:
    `p0` - the left-hand operand
    `op` - the operator, as a token returned by the Tokenizer (e.g. Token.AND)
    `p1` - the right-hand operand

Method Detail

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression. Default implementation for binary operators that accept any kind of operand

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### setFlattened

    public void setFlattened(boolean flattened)

  Mark an expression as being "flattened". This is a collective term that includes extracting the string value or typed value, or operations such as simple value construction that concatenate text nodes before atomizing. The implication of all of these is that although the expression might return nodes, the identity of the nodes has no significance. This is called during type checking of the parent expression.

  Overrides:
    `setFlattened` in class `Expression`
  Parameters:
    `flattened` - set to true if the result of the expression is atomized or otherwise turned into an atomic value

### promote

    public Expression promote(PromotionOffer offer,
                              Expression parent)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Expression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public Iterator<Expression> iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### getOperator

    public int getOperator()

  Get the operator

  Returns:
    the operator, for example `Token.PLUS`

### getOperands

    public Expression[] getOperands()

  Get the operands

  Returns:
    the two operands of the binary expression, as an array of length 2

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality. Default implementation returns [0..1] if either operand can be empty, or [1..1] otherwise.

  Specified by:
    `computeCardinality` in class `Expression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    `StaticProperty.NON_CREATIVE`. This is overridden for some subclasses.

### isCommutative

    protected static boolean isCommutative(int operator)

  Determine whether a binary operator is commutative, that is, A op B = B op A.

  Parameters:
    `operator` - the operator, for example `Token.PLUS`
  Returns:
    true if the operator is commutative

### isAssociative

    protected static boolean isAssociative(int operator)

  Determine whether an operator is associative, that is, ((a^b)^c) = (a^(b^c))

  Parameters:
    `operator` - the operator, for example `Token.PLUS`
  Returns:
    true if the operator is associative

### isInverse

    protected static boolean isInverse(int op1,
                                       int op2)

  Test if one operator is the inverse of another, so that (A op1 B) is equivalent to (B op2 A). Commutative operators are the inverse of themselves and are therefore not listed here.

  Parameters:
    `op1` - the first operator
    `op2` - the second operator
  Returns:
    true if the operators are the inverse of each other

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Get a hashCode for comparing two expressions. Note that this hashcode gives the same result for (A op B) and for (B op A), whether or not the operator is commutative.

  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax

  Overrides:
    `toString` in class `Expression`
  Returns:
    a representation of the expression as a string

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the output destination for the displayed expression tree

### explainExtraAttributes

    protected void explainExtraAttributes(ExpressionPresenter out)

  Add subclass-specific attributes to the expression tree explanation. Default implementation does nothing; this is provided for subclasses to override.

  Parameters:
    `out` - the output destination for the displayed expression tree

### displayOperator

    protected String displayOperator()

  Display the operator used by this binary expression

  Returns:
    String representation of the operator (for diagnostic display only)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.